/*
	Problem bralcev in pisateljev
	Imamo ve bralcev, ki berejo tisto, kar zapisujejo pisatelji.
	Med pisanjem enega pisatelja ne sme pisati noben drug pisatelj. 
	Noben pisatelj ne sme pisati med branjem.
	
	skelet programa
*/
#define HAVE_STRUCT_TIMESPEC	

#include <stdio.h>
#include <pthread.h> 
#include <windows.h>

#define BRALCEV 4
#define PISATELJEV 2
#define CIKLOV_PISANJA 5

void *bralec(void *par)
{
	int i = 0;
	int bralec = (int)par;
	
	while (1) 
	{
		printf("Bralec %d: zacetek.\n", bralec);
		Sleep(i*3);
		printf("Bralec %d: konec.\n", bralec);
		Sleep(i*3);
		i++;
	}
	return(NULL);
}

void *pisatelj(void *par)
{ 
	int i;
	int pisatelj = (int)par;

	for (i=0; i<CIKLOV_PISANJA; i++) 
	{
		printf("Pisatelj %d: zacetek.\n", pisatelj);
		Sleep(i*2);
		printf("Pisatelj %d: konec.\n", pisatelj);
		Sleep(i*2);
	}
	return(NULL);
}

int main(void)  
{
	int i;
	pthread_t thread_bralec[BRALCEV];
	pthread_t thread_pisatelj[PISATELJEV]; 

	for( i=0; i<BRALCEV; i++)
		pthread_create(&thread_bralec[i], NULL, bralec, (int *)i);

	for( i=0; i<PISATELJEV; i++)
		pthread_create(&thread_pisatelj[i], NULL, pisatelj, (int *)i);
	
	for( i=0; i<PISATELJEV; i++)
		pthread_join(thread_pisatelj[i], NULL);
		
	return 0;
}
